/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://java.net/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.taxonomy;

import javax.annotation.Nonnull;
import it.tidalwave.util.spi.ExtendedFinderSupport;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface Finder<T> extends ExtendedFinderSupport<T, Finder<T>> 
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public static enum SortCriterion implements it.tidalwave.util.Finder.SortCriterion
      {
        DISPLAY_NAME
      }

    /*******************************************************************************************************************
     *
     * Sets the name for the query. Only entities with the given name will be returned.
     *
     * @param  displayName  the name
     * @return              the finder itself
     *
     ******************************************************************************************************************/
    @Nonnull
    public Finder<T> withDisplayName (final @Nonnull String displayName);
  }
